Ubuntu

[MASTER] Adobe Flash does not support WMODE (Flash content always rendered on top of web pages)

Reported by Martin Flack on 2006-06-13
456
This bug affects 20 people
Affects Status Importance Assigned to Milestone
Mozilla Firefox
Fix Released
Medium
nspluginwrapper
Fix Released
Undecided
Unassigned
firefox-3.0 (Ubuntu)
Undecided
Unassigned
firefox (Ubuntu)
Undecided
Unassigned
flashplugin-nonfree (Ubuntu)
Medium
Mozilla Bugs
gnash (Ubuntu)
Undecided
Unassigned
nspluginwrapper (Ubuntu)
Undecided
Unassigned

Bug Description

The Adobe Flash plugin does not support the "wmode" option used by many websites.

As a result, all Flash is drawn on top of other content, often obscuring major parts of web pages and making it unusable.

*There is unfortunately nothing we can do.* If you want this fixed, vote for the bug on Adobe's bug tracker.

http://bugs.adobe.com/jira/browse/FP-80

Test case:

http://www.ishares.com/home.jhtml

Try to operate the menus at left or top. The boxes are obscured by the Flash content.

For more information on this mechanism, read http://kb.adobe.com/selfservice/viewContent.do?externalId=tn_15523

..probably can be done on Linux since it works on Windows, but dunno where to
start. Did 4.x have an implementation?

No, it didn't.

setting to future

This is a platform parity issue, and thus not an enhancement.

Braden: I would like to open this bug up to a more focused issue and thus change
the OS to ALL - as well as change the summary to state "Need windowless plug-in
support for Flash" would that be acceptable to you?

beppe: I think "Windowless plug-in support for X" pretty accurately describes
the problem here. The problem is by no means unique to Flash. It sounds to me
that if we did what you describe, this would be a duplicated of bug 44322. This
bug exists because bug 44322 was resolved without addressing this issue for X.
If it is preferred that a single bug be used to track this issue on all
platforms--and especially if there exist problems with windowless plug-ins on
Windows and/or Mac that would be motivation for broadening the scope of this
bug--I suggest that it is appropriate to reopen bug 44322 and mark this one as a
duplicate of it.

I think bug 44322 should stay closed, it was about reproducing the NS 4.x
functionality. The title of this bug seems to describe pretty well what this bug
is about.

Has anyone verified that windowless plugins don't work under X, I'm sure they
don't work, but a test case would be useful. I'd probably have a look at this if
I didn't have to go to the effort of learning how to implement the plugin side
of a windowless plugin under X. I wouldn't expect a fix to be too difficult,
there is a lot of #ifdef'd code in the windowless code that passes windows
specific messages - I would guess that we just need to work out what the
appropriate action would be for X in each of these cases.

there is no windowless plug-in support on X, and never been, even in 4.x world,
therefore I'm not aware of any test cases,
anyway I wouldn't change anything in this bug, it is valid generic X bug,
not only flash relatead.

If someone can give me the hooks to do an XCopyArea from the browser window to
the Flash buffer I will implement this. I have all the framework in place, it
seems to work, I just need to get the browser pixels at the start of our redraw
cycle. Note that hooks to do an XCopyArea from an offscreen X image holding
the browser window image would be preferable though I imagine one of these
doesn't exist.

Hi Ed, I had just started looking at getting this working. Can you attach a
patch for the work that you have done?

All the work I've done is in our plugin, so there is no patch that will be of
much use to you. I've basicly just implemented the Windowless code we are
using in our Mac player up to the point that where I need X11 hooks to get an
XImage from the browser.

I was looking at implementing this in a similar way to windows. So, that an
XEvent will get passed through HandleEvent. I was thinking of using an Expose
event and passing the drawable through in the Window parameter. Would that work
for you? I'll try to put together a patch this weekend.

If the drawable is an off screen XImage it will work. If the drawable is a
window the flicker will be unacceptable because there will be a long period
while the browser background is on screen. I'm told Windowless mode isn't
supported on Mac Classic for this same reason, flicker.

There are also needs to be a protocol on who ultimately puts the off screen
image on screen. I'm assuming it will be the plugin but I'm not sure what the
pro's and con's are.

The drawable will be an offscreen image, which will only be valid for use for
the length of the call to HandleEvent. The browser will be passing its current
backbuffer through to the plugin, to allow the plugin to render directly into it.

Created attachment 104801
Rough patch for implementing windowless support on Unix

The patch does not work in its current state, I have attached it so I don't
lose what I've done. It is also not very polished, e.g. I am sure there is a
better way of doing the GTK specific stuff without #ifdefing it everywhere. The
aim at the moment is to get it working and worry about tidying it up later!

On the plugin side I have implemented HandleEvent as follows:
uint16 nsPluginInstance::HandleEvent(void* aEvent)
{
  NPEvent * event = (NPEvent *)aEvent;
  switch (event->type) {
    case GraphicsExpose:
    {
 XGraphicsExposeEvent* exevent = (XGraphicsExposeEvent*)event;

 //GC gc = XCreateGC(exevent->display, exevent->drawable, 0, NULL);
 //mWindow is stored from the call to SetWindow
 if(!mWindow)
    return 1;
 GC gc = (GC)(mWindow->window);
 if (!gc)
    return 1;
 XDrawRectangle(exevent->display, exevent->drawable, gc, x, y, w, h);

However it crashes inside the call to XDrawRectangle, which I guess means that
there is something wrong with the drawable. I'm not really an expert on Xlib so
if anyone has any suggestions I'll be grateful.

I wish I'd known about this bug!

There is a fairly easy way to do this. When we call Paint() on the plugin frame,
it should synthesize an event and pass it to the plugin, along with a drawable
obtained from the nsIRenderingContext parameter. This drawable will be an
*offscreen* pixmap (because the view manager paints frames onto an offscreen
area for double-buffering purposes).

*** Bug 215237 has been marked as a duplicate of this bug. ***

*** Bug 231557 has been marked as a duplicate of this bug. ***

*** Bug 240781 has been marked as a duplicate of this bug. ***

Created attachment 148794
Rough patch based on david's patch

Using unixprinting plugin as testcase.

Created attachment 148795
test page of this patch

Using /modules/plugin/samples/unixprinting/libunixprintplugin.so as the plugin.

In , Vdvo (vdvo) wrote :

Is there anything I can do to push this forward? Does the patch need testing,
for example? Is there a reason there is no review request for it? Thank you.

Note that on Fedora Core 3 and latest flash, wmode (transparent flash) works -
http://www.macromedia.com/support/flash/ts/documents/wmode.htm

Are you sure?

"Note: Because of restrictions in this form, the layer is simulated. Viewing
the source of this page will not reflect the method accurately."

Missed that. http://www.communitymx.com/content/source/E5141/wmodetrans.htm
indeed doesn't work on linux correctly, my bad.

Created attachment 169650
revised patch against trunk

One of the things I am unsure of is how I am obtaining the drawable:

nsObjectFrame.cpp
 exposeEvent.drawable = (Drawable)win->GetNativeData(NS_NATIVE_WIDGET);

So maybe others who have worked on this patch or know layout internals better
can collaborate.

I'll post a revised test case next.

Created attachment 169652
New Test page using unixprintplugin

I'll have a look at this.

+ exposeEvent.drawable =
(Drawable)win->GetNativeData(NS_NATIVE_WIDGET);

You want NS_NATIVE_WINDOW so that this can work in GTK1.

Other than that, this looks pretty good on the painting side. But the event
handling is missing. You need something like this:

http://lxr.mozilla.org/mozilla/source/layout/generic/nsObjectFrame.cpp#3883

Fix that and I think we're close to having something we can check in ... need
testing from the Macromedia folks though, really.

It would be great if we can land this for 1.8/FF 1.1. I'll be happy to review it
when the code is ready.

Pete, do you want to take this bug and address roc's comments?

*** Bug 307640 has been marked as a duplicate of this bug. ***

*** Bug 292149 has been marked as a duplicate of this bug. ***

*** Bug 297066 has been marked as a duplicate of this bug. ***

Does anyone know who can be contacted regarding this long-standing issue? Perhaps somebody from another X project, maybe a Gnome/KDE developer? Maybe compiling a list of websites where this becomes an issue would show the severity of this problem.

Someone should just take the patch in this bug, update it to review comments and trunk, and get it checked in...

I had this working about a year ago ..

(In reply to comment #29)
> + exposeEvent.drawable =
> (Drawable)win->GetNativeData(NS_NATIVE_WIDGET);
>
> You want NS_NATIVE_WINDOW so that this can work in GTK1.
>
> Other than that, this looks pretty good on the painting side. But the event
> handling is missing. You need something like this:
>
> http://lxr.mozilla.org/mozilla/source/layout/generic/nsObjectFrame.cpp#3883
>
> Fix that and I think we're close to having something we can check in ... need
> testing from the Macromedia folks though, really.

a field "window" in the "NPWindow" Structure, such as In Windows Platform, just explained as a hdc.
can we add a variable in the class "ns4xPluginInstance" to hold the Drawable.
if it is windowless. then we can retrieve it. if it is windowed ,we just omit it.

The KDE guys have recently fixed a similar problem in KHTML.
See http://bugs.kde.org/show_bug.cgi?id=31121 .

That is really a different problem. As far as I can tell, what they've done there doesn't allow stuff like drawing text over a plugin.

Changed in firefox:
status: Unconfirmed → Confirmed
Changed in firefox:
status: Unknown → Unconfirmed
David Farning (dfarning) on 2007-01-21
Changed in firefox:
assignee: nobody → mozillateam
importance: Undecided → Medium
David Farning (dfarning) on 2007-02-24
Changed in flashplugin-nonfree:
assignee: mozillateam → mozilla-bugs
Changed in firefox:
status: Unconfirmed → Rejected
Changed in firefox:
status: Unknown → In Progress
Changed in firefox:
status: In Progress → Fix Released
Changed in firefox:
status: New → Confirmed
Alexander Sack (asac) on 2008-01-03
Changed in firefox-3.0:
status: New → Fix Released
Changed in firefox:
status: Confirmed → Won't Fix
description: updated
description: updated
Daniel T Chen (crimsun) on 2008-07-03
Changed in flashplugin-nonfree:
status: Confirmed → Fix Released
brad (bradlambeth) on 2008-07-11
Changed in nspluginwrapper:
status: Confirmed → Fix Released
Changed in nspluginwrapper:
status: Fix Released → New
Changed in nspluginwrapper:
status: New → Fix Released
Changed in flashplugin-nonfree:
status: Fix Released → Incomplete
Changed in firefox:
status: Fix Released → Confirmed
Dara Adib (daradib) on 2008-08-12
Changed in gnash:
status: New → Confirmed
Changed in flashplugin-nonfree:
status: Incomplete → Confirmed
Changed in firefox:
status: Confirmed → Fix Released
198 comments hidden view all 278 comments

Interestingly, the Acer Aspire One manages to do all this with Firefox2.0.0.14 and Flash9r124.

Unfortunately, Linpus' source is nowhere to be found. But their libflashplayer.so is definitely unmodified.

Pat, have you tried the yahoo.com link in my comment #137 ?
The dropdown menus on that page drop down *behind* the chart
and are unreadable with any Flash but 10beta. At least for me.

greg (grigorig) wrote :

I can confirm that the new nspluginwrapper 1.1.0 development version works a lot better than the old 0.9.x/1.0.0. WMODE is indeed fixed, I can see the menus at adobe.com for example. And at least for me, Flash 10 is a whole lot better in terms of performance -- especially with activated hardware acceleration.

With Intrepid shipping Flash 10, I think the new nspluginwrapper is a must!

Tien Nguyen (tienhn) wrote :

@Grigori,
Could you help me with direction to install nspluginwrapper 1.1.0?
Thanks,

greg (grigorig) wrote :

Nothing special at all. apt-get build-dep nspluginwrapper && ./configure && make && make install. You need to re-install all your wrapped plugins into nspluginwrapper after that. That's it.

Is this really the right platform to discuss this?

Tien Nguyen (tienhn) wrote :

Thanks for this reply. I tried the Flash 10 beta, Aug-2008 version from here: http://labs.adobe.com/technologies/flashplayer10/ and It seems to resolve the problem. All of the mentioned troubled web site works fine for me with Flash 10 beta plug in installed.

Still have not used nspluginwrapper.

hey, this only happens to me in ubuntu. on mac or fail-dows it doesnt happen.

http://www.dell.com look at the menus on their homepage, obscured by the flash

Scott Talbert (swt-techie) wrote :

Now that Adobe has officially released Flash Player 10 (with Linux WMODE support), would it be possible to get it released for Hardy?

Thanks,
Scott

I guess it will come in due course. It's in multiverse so it's not subject
to the version stability requirements that packages in main are.

Daniel T Chen (crimsun) on 2008-10-28
Changed in nspluginwrapper:
status: New → Fix Released
Changed in flashplugin-nonfree:
status: Confirmed → Fix Released
Jordan Erickson (lns) wrote :

---
# dpkg -l|grep flashplugin
ii adobe-flashplugin 10.0.12.36-1hardy1
---
# dpkg -l|grep firefox-3.0
ii firefox-3.0 3.0.3+build1+nobinonly-0ubuntu0.8.04.1 safe and easy web browser from Mozilla
---
# uname -a
Linux ltsp-server 2.6.24-21-server #1 SMP Wed Oct 22 00:18:13 UTC 2008 i686 GNU/Linux
---

From an LTSP thin-client, I go to http://change.gov/newsroom/blog/ - and view the YouTube video, and then mouse-over the "Agenda" menu, it shows BEHIND the YouTube flash window. So it looks like it's not fixed all together yet.. ?

goto (gotolaunchpad) wrote :

With a 64 bit up to date Intrepid and gnash I still have this problem.
Thanks.

3Olivier (rogericke) wrote :

I opened bug 312973 with same problem:

Running ubuntu 8.04 with firefox 3.0.5 and flash 10
I try website truthofthespoon.net/index03.html and the menu does not show the letters, the scroll-down menu does not work (see attached screen print).
On website vueling.com when you check the date option, the main advert stays on top therefore hiding any possibility of choosing a date.
On a windows machine with same firefox and flash, the display is correct.
My linux machine is a laptop FUJITSU-SIEMENS ESPRIMO V5535.

By the way, I'm a newbie.

mtb-cliff (pagedynamix) wrote :

I agree that this is still an issue with FF3.0.5 and Adobe Flash 10.0 r15 in that the flash overlays cover up the DHTML. The funny things is that you can see the DHTML being rendered and then the Flash covers it up. It is especially noticeable at teh following airmiles.ca site:

www.airmiles.ca and the rewards link: https://www.airmiles.ca/arrow/RewardsHome?selectedCategoryId=cat670016

Cliff.

mtb-cliff (pagedynamix) wrote :

Scratch my last comment. I still had the /etc/adobe/mms.cfg file in place. As soon as I commented out the WindowlessDisable=True everything worked as it supposed to work.

Tien Nguyen (tienhn) wrote :

Hi All,
I am on AMD64 platform. I found the release candidate Flash 10 from Adobe lab:

http://labs.adobe.com/technologies/flashplayer10/releasenotes_64bit.html

This version does not need nspluginwrapper and I have no problem viewing any of the trouble flash pages listed here.

Hope this helps,
Cheers,

Witold Mamczarz (m-mamczarz) wrote :

The new Adobe plug-in seems to solve the problem. What I did is:
1. I opened Synaptic
2. Pushed on search button
3. Typed "flash"
4. I Found Installed plug-in (it was flashplugin-nonfree 9.0.152) and marked it to uninstall
5. Processed changes
6. Point 2 and 3 again
7. I found the new Adobe plug-in (it was the first one Adobe-flashplugin 10.0.15.3) and installed it

When I installed Adobe plug-in without uninstalling old version the problem stayed.

enjoy

John Vivirito (gnomefreak) wrote :

On 02/05/2009 07:14 AM, Witold Mamczarz wrote:
> The new Adobe plug-in seems to solve the problem. What I did is:
> 1. I opened Synaptic
> 2. Pushed on search button
> 3. Typed "flash"
> 4. I Found Installed plug-in (it was flashplugin-nonfree 9.0.152) and marked it to uninstall
> 5. Processed changes
> 6. Point 2 and 3 again
> 7. I found the new Adobe plug-in (it was the first one Adobe-flashplugin 10.0.15.3) and installed it
>
> When I installed Adobe plug-in without uninstalling old version the
> problem stayed.
>
> enjoy
>
Starting the the AMD plugin it is not stable and I'm kind of sceptical
about adding it to any release including Jaunty without a stable release
ETA from Adobe.
We do not recommend using adobes version. Are you able to reproduce this
with our version of flash 10?

--
Sincerely Yours,
    John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

"How can i get lost, if i have no where to go"
    -- Metallica from Unforgiven III

I'm using:

Ubuntu 8.04 (Hardy)
Firefox 3.0.6
adobe-flashplugin 10.0.15.3-1hardy2

and I'm still having the problem - any advice please?

I was previously using flashplugin-nonfree but following the advice of a comment here I uninstalled it and installed the flash package above, but the problem has remained.

Thanks!

Alexander Jones (alex-weej) wrote :

Firstly check you have nothing in /etc/adobe

Secondly tell us what website you're viewing and we can check.

Hi Alexander,

Nothing in /etc/adobe (dir doesn't exist)

its happening on multiple sites, but off the top of my head:

www.nashuamobile.com -> the dropdown menu items just above the blackberry flash ad (such as "You@NashuaMobile","Phones" etc.).

Thanks!

Check in Firefox which plugin it uses. Should be "Shockwave Flash 10.0 r15".
If it is possible you have another else plugin installed.

The site seems be showed correctly. (Ubuntu 8.04, firefox 3.06)

Richard Sadie pisze:
> Hi Alexander,
>
> Nothing in /etc/adobe (dir doesn't exist)
>
> its happening on multiple sites, but off the top of my head:
>
> www.nashuamobile.com -> the dropdown menu items just above the
> blackberry flash ad (such as "You@NashuaMobile","Phones" etc.).
>
> Thanks!
>
>

Works for me as well. I previously had issues, but that was due to the
"fixes" that I had in for the earlier releases of the Flash player
plugin. However, after I edited the mms.cfg in /etc/adobe it works fine.
I am running 10.0 r15 as well in Ubuntu 8.04 with FF 3.06.

Just out of curiousity, are you running NoScript as a FF Plugin and
AdBlock Plus? If so, please check the settings to ensure that you are
allowing the site.

Witold Mamczarz wrote:
> Check in Firefox which plugin it uses. Should be "Shockwave Flash 10.0 r15".
> If it is possible you have another else plugin installed.
>
> The site seems be showed correctly. (Ubuntu 8.04, firefox 3.06)
>
>
> Richard Sadie pisze:
>
>> Hi Alexander,
>>
>> Nothing in /etc/adobe (dir doesn't exist)
>>
>> its happening on multiple sites, but off the top of my head:
>>
>> www.nashuamobile.com -> the dropdown menu items just above the
>> blackberry flash ad (such as "You@NashuaMobile","Phones" etc.).
>>
>> Thanks!
>>
>>
>>
>
>

Yep Firefox shows it's using "Shockwave Flash 10.0 r15".
No NoScript or Adblock installed :(

On 02/12/2009 04:16 PM, Richard Sadie wrote:
> I'm using:
>
> Ubuntu 8.04 (Hardy)
> Firefox 3.0.6
> adobe-flashplugin 10.0.15.3-1hardy2
>
> and I'm still having the problem - any advice please?
>
> I was previously using flashplugin-nonfree but following the advice of a
> comment here I uninstalled it and installed the flash package above, but
> the problem has remained.
>
> Thanks!
>
This was a bad idea. by installiog the upstream package as oppsed to
ours its hard to test ours if we add a updated package. If upstream
package has same issue its most likely upstreams fault. Please try to
locate their bug tracker and report it ther as well.

--
Sincerely Yours,
    John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

"How can i get lost, if i have no where to go"
    -- Metallica from Unforgiven III

nblracer (nblracer) wrote :

Still having problems on
citi cards page

running ubuntu intriped
with flash 10

*** Bug 461467 has been marked as a duplicate of this bug. ***

*** Bug 462489 has been marked as a duplicate of this bug. ***

avracx (jhon-cewex) on 2009-07-14
Changed in flashplugin-nonfree (Ubuntu):
status: Fix Released → Confirmed
Changed in nspluginwrapper (Ubuntu):
status: Fix Released → Confirmed

On 07/14/2009 09:02 AM, avracx wrote:
> ** Changed in: flashplugin-nonfree (Ubuntu)
> Status: Fix Released => Confirmed
>
> ** Changed in: nspluginwrapper (Ubuntu)
> Status: Fix Released => Confirmed
>
Wasn't this fixed in flash 10?

--
Sincerely Yours,
    John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

"How can i get lost, if i have no where to go"
    -- Metallica from Unforgiven III

decorum (decorum) on 2009-07-29
Changed in flashplugin-nonfree (Ubuntu):
status: Confirmed → Fix Committed
Changed in firefox:
status: Fix Released → Fix Committed
Micah Gersten (micahg) wrote :

Please don't change the status of upstream bugs.

Changed in firefox:
status: Fix Committed → Fix Released
Changed in firefox-3.0 (Ubuntu):
status: Fix Released → Fix Committed
Micah Gersten (micahg) on 2009-09-22
Changed in firefox-3.0 (Ubuntu):
status: Fix Committed → Fix Released
John Vivirito (gnomefreak) wrote :

On 09/22/2009 03:31 AM, Micah Gersten wrote:
> ** Changed in: firefox-3.0 (Ubuntu)
> Status: Fix Committed => Fix Released
>
ok people have been changing status of packages. can you
please let us know why you are changing status. micah i know
why you did but i deleted "i hate vista's" email by mistake.
however this goes for all.

--
Sincerely Yours,
    John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

"How can i get lost, if i have no where to go"
    -- Metallica from Unforgiven III

Umang Varma (umang) wrote :

I'm still encountering this problem on Ubuntu 9.10 Karmic, Firefox 3.5 (3.5.6+nobinonly-0ubuntu0.9.10.1), Shockwave Flash 10.0 r42.

Do I need to install anything extra?

Thanks

Micah Gersten (micahg) wrote :

@umang

This was fixed in Firefox 3. If you feel you are experiencing a regression, please file a new bug (ubuntu-bug firefox-3.5) and mention this bug #.

Thanks.

Umang, are you using 64 bit? By default, Ubuntu uses 32 bit flash player with nspluginwrapper. Try the 64 bit flash player from here: http://labs.adobe.com/technologies/flashplayer10/64bit.html

Umang Varma (umang) wrote :

No, I have an "P III", so I am using 32 bit Ubuntu (and 32 bit flash also).

Nicolò Chieffo (yelo3) wrote :

I don't have this problem with nspluginwrapper in the developement version of ubuntu. can we close the task?

Umang Varma (umang) wrote :

Yes. I won't be able to test this issue soon and seemed to be the only one affected at that point (I had asked a few people with similar configurations whether they had any problem). I'd assume it's fixed if nobody is affected.

Changed in firefox:
importance: Unknown → Medium

There is also an updated official Adobe version of the 64bit Flash player here, as of earlier this week : http://labs.adobe.com/technologies/flashplayer10/
Please also note that Adobe hasn't recommended the use of nspluginwrapper for some time...

Thomas Hotz (thotz) wrote :

Has anybody tested this with flash plugin version 11?

Thomas Hotz (thotz) on 2012-11-06
Changed in gnash (Ubuntu):
status: Confirmed → Invalid
Changed in nspluginwrapper (Ubuntu):
status: Confirmed → Fix Released
Changed in flashplugin-nonfree (Ubuntu):
status: Fix Committed → Incomplete
Thomas Hotz (thotz) wrote :

This should be fixed now, please correct me if I'm wrong. Tested this page with Ubuntu 13.04 with Adobe flash player 11.2.x.x .

Changed in flashplugin-nonfree (Ubuntu):
status: Incomplete → Fix Released
Displaying first 40 and last 40 comments. View all 278 comments or add a comment.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Related questions

Remote bug watches

Bug watches keep track of this bug in other bug trackers.